/**
 * @class Sb.WindowManager
 * @singleton
 */
Sb.WindowManager = Ext.extend(Object, {

	_levels: [],

	dragZIndex: 30000,

	/**
	 * Creates group and register window in it
	 * @param {Window} win The Window to register.
	 * @param {number} level Level to register on.
	 */
	register : function(win, level){
		if (!level) {
			level = 1;
		}

		var manager = this.getManager(level);
		manager.register(win);
	},

	/**
	 * Creates group if needed and return it
	 * @param {number} level Level to return.
	 */
	getManager : function (level) {
		if (!this._levels[level]) {
			if (level == 9) { // Use ExtJS singletone for modal dialogs
				this._levels[level] = Ext.WindowMgr;
			} else {
				this._levels[level] = new Ext.WindowGroup();
			}
			this._levels[level].zseed = level * 1000;
		}
		return this._levels[level];
	}
});
