/**
 * @class Sb.editor.MainWindow.FakeProgressBar
 * @extends Ext.ProgressBar
 * Class for publish progressbar
 * @constructor
 * @param {Object} config The config object
 * @xtype fakeprogressbar
 */
Sb.editor.MainWindow.FakeProgressBar = Ext.extend(Ext.ProgressBar, {
	/*
	 * @param {Object} config (optional) Configuration options
	 * @return {Sb.editor.MainWindow.FakeProgressBar} this
	 */
	wait: function(o) {
		if (!this.waitTimer) {
			var scope = this;
			o = o || {};
			this.updateText(o.text);
			this.waitTimer = Ext.TaskMgr.start({
				run: function(i){
					var progress;
					var time = new Date().getTime() - this.waitTimer.taskStartTime;
					if (time < o.duration / 9) {
						progress = (9 * time) / (10 * o.duration);
					} else {
						progress = 1 - 6 * Math.sqrt(o.duration * time) / (65 * time - 5 * o.duration);
					}

					this.updateProgress(progress, String.format(SbGetLocaleByKey('publishingSite'),
						'<b>' + Math.ceil(progress * 100) + '%</b>')
						, o.animate);
				},
				interval: o.interval || 100,
				scope: scope
			});
		}
		return this;
	},

	gotoEnd: function(o) {
		if (this.waitTimer) {
			Ext.TaskMgr.stop(this.waitTimer);
		}
		o = o || {};
		this.waitTimer = Ext.TaskMgr.start({
			run: function(i) {
				var time = new Date().getTime() - this.waitTimer.taskStartTime;
				var progress = this.value + Math.pow((time - ( 1 - this.value) * 1000) / 1000, 2);
				this.updateProgress(progress, String.format(SbGetLocaleByKey('publishingSite'),
					'<b>' + Math.ceil(progress * 100) + '%</b>'));
				if (progress > 1) {
					Ext.TaskMgr.stop(this.waitTimer);
				}
			},
			interval: 50,
			duration: 1000,
			scope: this,
			onStop: function() {
				if (o.fn) {
					o.fn.apply(o.scope || this);
				}
			}
		});
	}
});

Ext.reg('fakeprogressbar', Sb.editor.MainWindow.FakeProgressBar);