Sb.form.ColorDecorationPanel = Ext.extend(Sb.form.FieldGroup, {

	/**
	 * Possible decoration values/keys
	 */
	decorations: ['Bold', 'Italic', 'Underline'],

	constructor: function(config) {
		config = Ext.apply({
			colorComboWidth	: 'auto',
			noColorText		: SbGetLocaleByKey('autoColor'),
			widgetContolCls	: '',
			children		: 'color,background,decoration'
		}, config);

		Sb.form.ColorDecorationPanel.superclass.constructor.call(this, config);

		var reChildren	= new RegExp(config.children.replace(/,/g, '|'), 'i');

		if (reChildren.test('color')) {
			var colorCombo = new Sb.form.ColorDropDown({
				itemId		: 'Color',
				iconCls		: 'x-edit-forecolor',
				fieldLabel	: SbGetLocaleByKey('colorDecorationPanelColor'),
				itemCls		: config.widgetContolCls + 'color',
				isShowColorField: false,
				width		: config.colorComboWidth,
				noColorText	: this.noColorText
			});
			this.add(colorCombo);
		}

		if (reChildren.test('background')) {
			var backgroundCombo = new Sb.form.ColorDropDown({
				itemId		: 'BackgroundColor',
				iconCls		: 'x-edit-backcolor',
				fieldLabel	: SbGetLocaleByKey('colorDecorationPanelBackgroundArea'),
				itemCls		: config.widgetContolCls + 'background-color',
				isShowColorField: false,
				width		: config.colorComboWidth,
				noColorText	: this.noColorText
			});
			this.add(backgroundCombo);
		}

		if (reChildren.test('decoration')) {
			var decorationGroup = new Sb.form.FieldGroup({
				itemId		: 'Decoration',
				layout		: 'column',
				fieldLabel	: SbGetLocaleByKey('colorDecorationPanelDecoration'),
				itemCls		: config.widgetContolCls + 'decoration'
			});
			Ext.each(this.decorations, function(decoration) {
				var decorationButton = new Ext.Button({
					itemId		: decoration,
					iconCls		: 'x-edit-' + decoration.toLowerCase(),
					enableToggle: true
				});
				decorationGroup.add(decorationButton);
			});
			this.add(decorationGroup);
		}
	}
});