Sb.form.FieldGroup = Ext.extend(Ext.Container, {
	constructor: function(config) {
		config = Ext.apply({
			layout			: 'form',
			border			: false,
			labelAlign		: 'top'
		}, config);
		if (!config.width) {
			config.autoWidth = true;
		}
		if ('card' == config.layout) {
			config = Ext.apply({
				layoutConfig : {
					deferredRender : true
				}
			}, config);
		}
		Sb.form.FieldGroup.superclass.constructor.call(this, config);
	},

	/**
	 * Tries to find component and toggle it by show/hide.
	 * If state is defined, then tries to set it`s visibility in that state.
	 *
	 * @param {String|Ext.Component} component itemId of component or just component
	 * @param {Boolean} state State, that default undefined
	 */
	toggle: function(component, state) {
		if (Ext.isString(component)) {
			var componentId = component;
			component = this.getComponent(componentId);
			if (undefined == component) {
				throw new Error('Component with itemId ' + componentId + ' not found');
			}
		}
		if (undefined == state) {
			state = component.hidden;
		}
		var fn = this.doToggle.createDelegate(this, [component, state]);
		if (!component.rendered) {
			component.on('render', fn, null, {single: true});
		} else {
			fn();
		}
	},

	/**
	 * Toggle component by show or hide as in state.
	 *
	 * @param {Ext.Component} component
	 * @param {Boolean} state
	 */
	doToggle: function(component, state) {
		var toggleObj		= component;
		if (component.itemCt && component.itemCt != this) {
			toggleObj		= component.itemCt;
			toggleObj.setVisibilityMode(Ext.Element.DISPLAY);
		}
		toggleObj.setVisible(state);
	}
});
Ext.reg('fieldgroup', Sb.form.FieldGroup);