/**
 * @class Sb.model.ContainerVerticalWidget
 * @extends Sb.model.Widget
 * Class for vertical container widget model
 * @constructor
 * @param {Object} config The configuration options for the vertical container widget model
 */
Sb.model.ContainerVerticalWidget = Ext.extend(Sb.model.Widget, {
	constructor: function(config) {
		config = Ext.apply({
			type: 'container_vertical'
		}, config);

		Sb.model.ContainerVerticalWidget.superclass.constructor.call(this, config);
		this.widgets.on('add', this.onWidgetAdd, this);
		this.widgets.on('remove', this.onWidgetRemove, this);
	},

	onWidgetAdd: function(index, widget, key) {
		if (widget instanceof Sb.model.SharedWidget) {
			Sb.Editor.model.rootPage.addSharedWidget(this, widget, index);
		}
	},

	onWidgetRemove: function(widget) {
		if (widget instanceof Sb.model.SharedWidget) {
			Sb.Editor.model.rootPage.removeSharedWidget(this, widget);
		}
	},

	onDestroy: function() {
		this.widgets.un('add', this.onWidgetAdd, this);
		this.widgets.un('remove', this.onWidgetRemove, this);
		Sb.model.ContainerVerticalWidget.superclass.onDestroy.call(this);
	}
});