/**
 * @class Sb.widgetType.Header
 * @extends Sb.widgetType.Shared
 */
Sb.widgetType.Header = Ext.extend(Sb.widgetType.Shared, {
	isDroppableTo: function(region) {
		return ('header' == region);
	},

	isAvailable: function() {
		return this.cache.length == 0;
	},

	/**
	 * Fires when number of header widgets in changed
	 */
	onCacheChange: function() {
		this.toggleButton();
		Sb.widgetType.Header.superclass.onCacheChange.call(this);
	},

	/**
	 * Toggle button on widgets panel
	 */
	toggleButton: function() {
		this.toggle(this.isAvailable());
	},

	/**
	 * Fires when component register
	 */
	onComponentsAdd: function() {
		this.toggleButton();
		Sb.widgetType.Header.superclass.onComponentsAdd.call(this);
	},

	/**
	 * Instance factory with cache by uuid
	 *
	 * @param {Object} config The configuration options for the widget model
	 * @return {Sb.model.HeaderWidget}
	 */
	createInstance: function(config) {
		var widget = Sb.widgetType.Header.superclass.createInstance.call(this, config);
		return widget;
	}
});