/*!
 * Ext.ux.IconCombo Extension Class
 * @class Ext.ux.IconCombo
 * @extends Ext.form.ComboBox
 * @constructor
 * @param {Object} config Configuration options
 */
Ext.ns('Ext.ux');
Ext.ux.IconCombo = Ext.extend(Ext.form.ComboBox, {
	initComponent: function() {
		var config = {
			tpl: '<tpl for="."><div class="x-combo-list-item x-icon-combo-item {'
				+ this.iconClsField
				+ '}">{'
				+ this.displayField
				+ '}</div></tpl>'
		};

		// apply config
		Ext.apply(this, Ext.apply(this.initialConfig, config));

		// call parent initComponent
		Ext.ux.IconCombo.superclass.initComponent.apply(this, arguments);
	},

	onRender: function(ct, position) {
		// call parent onRender
		Ext.ux.IconCombo.superclass.onRender.apply(this, arguments);

		// adjust styles
		this.wrap.applyStyles({position: 'relative'});
		this.el.addClass('x-icon-combo-input');

		// add div for icon
		this.icon = Ext.DomHelper.append(this.wrap, {
			tag: 'div',
			style: 'position:absolute'
		});
	},

	afterRender: function() {
		Ext.ux.IconCombo.superclass.afterRender.apply(this, arguments);
		if (undefined !== this.value) {
			this.setValue(this.value);
		}
	},

	setIconCls: function() {
		var rec = this.store.query(this.valueField, this.getValue()).itemAt(0);
		if (rec && this.icon) {
			this.icon.className = 'x-icon-combo-icon ' + rec.get(this.iconClsField);
		}
	},

	setValue: function(value) {
		Ext.ux.IconCombo.superclass.setValue.call(this, value);
		this.setIconCls();
	},

	clearValue: function() {
		Ext.ux.IconCombo.superclass.clearValue.call(this);
		if (this.icon) {
			this.icon.className = '';
		}
	}
});
Ext.reg('iconcombo', Ext.ux.IconCombo);
