/*
 * @class Ext.ux.util.Color
 * Utility class for color manipulating
 * @singleton
 */
Ext.namespace("Ext.ux.util");Ext.ux.util.Color=function(){return{pack:function(c){var e=Math.round(c[0]*255);var d=Math.round(c[1]*255);var a=Math.round(c[2]*255);return"#"+(e<16?"0":"")+e.toString(16)+(d<16?"0":"")+d.toString(16)+(a<16?"0":"")+a.toString(16)},unpack:function(a){if(a.length==7){return[parseInt("0x"+a.substring(1,3))/255,parseInt("0x"+a.substring(3,5))/255,parseInt("0x"+a.substring(5,7))/255]}else{if(a.length==4){return[parseInt("0x"+a.substring(1,2))/15,parseInt("0x"+a.substring(2,3))/15,parseInt("0x"+a.substring(3,4))/15]}}},hsl2rgb:function(i){var k,j,a,e,f;var d=i[0],m=i[1],c=i[2];j=(c<=0.5)?c*(m+1):c+m-c*m;k=c*2-j;return[Ext.ux.util.Color.hue2rgb(k,j,d+0.33333),Ext.ux.util.Color.hue2rgb(k,j,d),Ext.ux.util.Color.hue2rgb(k,j,d-0.33333)]},hue2rgb:function(b,a,c){c=(c<0)?c+1:((c>1)?c-1:c);if(c*6<1){return b+(a-b)*c*6}if(c*2<1){return a}if(c*3<2){return b+(a-b)*(0.66666-c)*6}return b},rgb2hsl:function(i){var d,k,m,e,n,c;var a=i[0],f=i[1],j=i[2];d=Math.min(a,Math.min(f,j));k=Math.max(a,Math.max(f,j));m=k-d;c=(d+k)/2;n=0;if(c>0&&c<1){n=m/(c<0.5?(2*c):(2-2*c))}e=0;if(m>0){if(k==a&&k!=f){e+=(f-j)/m}if(k==f&&k!=j){e+=(2+(j-a)/m)}if(k==j&&k!=a){e+=(4+(a-f)/m)}e/=6}return[e,n,c]},isLight:function(b){var c=Ext.ux.util.Color.unpack(b);var a=Ext.ux.util.Color.rgb2hsl(c);return(a[0]<0.55&&a[2]>=0.5)||(a[0]>=0.55&&a[2]>=0.75)},isDark:function(a){return !Ext.ux.util.Color.isLight(a)},getVariant:function(c,d,b){var a=Ext.ux.util.Color.rgb2hsl(Ext.ux.util.Color.unpack(c));a[1]=d<=0?a[1]*(d+1):a[1]+(1-a[1])*d;a[2]=b<=0?a[2]*(b+1):a[2]+(1-a[2])*b;return Ext.ux.util.Color.pack(Ext.ux.util.Color.hsl2rgb(a))}}}();
/*
 * @class Ext.ux.ColorPicker
 * @extends Ext.BoxComponent
 */
Ext.ux.ColorPicker=Ext.extend(Ext.BoxComponent,{_radius:84,_square:100,_width:194,constructor:function(a){a=Ext.apply({delayPeriod:0,autoValue:null},a);Ext.ux.ColorPicker.superclass.constructor.call(this,a)},initComponent:function(){Ext.ux.ColorPicker.superclass.initComponent.apply(this,arguments);this.addEvents("change","select","mouseup");this.setRawValue(this.value,this.autoValue);delete this.value},onRender:function(){this.autoEl={cls:"x-colorpicker",cn:[{cls:"x-colorpicker-h"},{cls:"x-colorpicker-sl"},{cls:"x-colorpicker-thumb x-colorpicker-thumb-h"},{cls:"x-colorpicker-thumb x-colorpicker-thumb-sl"}]};Ext.ux.ColorPicker.superclass.onRender.apply(this,arguments);this.hEl=this.el.first();this.slEl=this.hEl.next();this.hThumb=this.slEl.next();this.slThumb=this.hThumb.next();this.initEvents()},initEvents:function(){this.mon(this.el,"mousedown",this.onMouseDown,this)},onMouseDown:function(a){a.stopEvent();if(this.disabled){return}this.focus();if(!this._dragging){Ext.getDoc().on("mousemove",this.onMouseMove,this);Ext.getDoc().on("mouseup",this.onMouseUp,this);this._dragging=true}var b=this.el.translatePoints(a.getXY());b.left-=this._width/2;b.top-=this._width/2;this._isCircleDrag=Math.max(Math.abs(b.left),Math.abs(b.top))*2>this._square;this.onMouseMove(a)},onMouseMove:function(d){var f=this.el.translatePoints(d.getXY());f.left-=this._width/2;f.top-=this._width/2;if(this._isCircleDrag){var c=Math.atan2(f.left,-f.top)/6.28;if(c<0){c+=1}this.setHSL([c,this.hsl[1],this.hsl[2]])}else{var b=Math.max(0,Math.min(1,-(f.left/this._square)+0.5));var a=Math.max(0,Math.min(1,-(f.top/this._square)+0.5));this.setHSL([this.hsl[0],b,a])}this.noColor=false;this.delayChange()},lastChangeTime:(new Date).getTime(),delayChange:function(){if(this.delayPeriod>0){var a=(new Date).getTime();var b=a-this.lastChangeTime;if(b>this.delayPeriod){this.lastChangeTime=a}else{return}}this.fireEvent("change",this,this.color)},onMouseUp:function(a){Ext.getDoc().un("mousemove",this.onMouseMove,this);Ext.getDoc().un("mouseup",this.onMouseUp,this);this._dragging=false;this.fireEvent("change",this,this.color);this.fireEvent("select",this,this.color);this.fireEvent("mouseup",this,this.color)},afterRender:function(){Ext.ux.ColorPicker.superclass.afterRender.apply(this,arguments);this.updateDisplay()},isChanged:true,setRawValue:function(b,a){this.isChanged=false;this.noColor=null==b;if(this.noColor){b="#000000"}var c=Ext.ux.util.Color.unpack(a||b);if(this.color!=b&&c){this.color=b;this.rgb=c;this.hsl=Ext.ux.util.Color.rgb2hsl(this.rgb);if(this.rendered){this.updateDisplay()}this.isChanged=true}return this},setValue:function(a){this.setRawValue(a);if(this.isChanged){this.fireEvent("change",this,this.color)}},getValue:function(a){if(this.noColor){return null}return this.color},setHSL:function(a){this.hsl=a;this.rgb=Ext.ux.util.Color.hsl2rgb(a);this.color=Ext.ux.util.Color.pack(this.rgb);if(this.rendered){this.updateDisplay()}return this},updateDisplay:function(){var a=this.hsl[0]*6.28;this.hThumb.setStyle({left:Math.round(Math.sin(a)*this._radius+this._width/2)+"px",top:Math.round(-Math.cos(a)*this._radius+this._width/2)+"px"});this.slThumb.setStyle({left:Math.round(this._square*(0.5-this.hsl[1])+this._width/2)+"px",top:Math.round(this._square*(0.5-this.hsl[2])+this._width/2)+"px"});this.slEl.setStyle("backgroundColor",Ext.ux.util.Color.pack(Ext.ux.util.Color.hsl2rgb([this.hsl[0],1,0.5])))}});Ext.reg("colorpicker",Ext.ux.ColorPicker);
/*
 * @class Ext.ux.VerticalTabPanel
 * @extends Ext.TabPanel
 * @author <a href="mailto:me@carina.net">Carina Stumpf</a>
 * @version 0.2
 *
 * An extension for Ext.TabPanel that enables tabs to be positioned on the left or right side of a TabPanel.
 */
Ext.ns("Ext.ux");Ext.ux.VerticalTabPanel=function(a){if(a.tabPosition=="left"||a.tabPosition=="right"){a.cls=a.cls||"";a.cls="ux-vertical-tabs "+a.cls;if(a.textAlign&&a.textAlign=="right"){a.cls="ux-vertical-tabs-alignright "+a.cls}a.cls=(a.tabPosition=="left"?"ux-vertical-tabs-left ":"ux-vertical-tabs-right ")+a.cls;this.intendedTabPosition=a.tabPosition;this.verticalTabs=true;a.tabPosition="top"}Ext.ux.VerticalTabPanel.superclass.constructor.call(this,a)};Ext.extend(Ext.ux.VerticalTabPanel,Ext.TabPanel,{tabWidth:150,afterRender:function(){Ext.ux.VerticalTabPanel.superclass.afterRender.call(this);if(this.verticalTabs){this.header.setWidth(this.tabWidth);this.header.setHeight(this.height||this.container.getHeight());this.header.addClass("x-vtab-panel-header")}Ext.fly(Ext.DomQuery.selectNode("ul:first",this.header.dom)).addClass("x-vtab-panel-header-ul")},adjustBodyWidth:function(a){if(this.verticalTabs){if(Ext.isIE6){this.bwrap.setWidth(a)}return a}else{return Ext.ux.VerticalTabPanel.superclass.adjustBodyWidth.call(this,a)}},adjustBodyHeight:function(a){if(this.verticalTabs){this.header.setHeight(a+(this.tbar?this.tbar.getHeight():0))}return Ext.ux.VerticalTabPanel.superclass.adjustBodyHeight.call(this,a)},getFrameWidth:function(){return Ext.ux.VerticalTabPanel.superclass.getFrameWidth.call(this)+this.verticalTabs?this.tabWidth:0},getFrameHeight:function(){return Ext.ux.VerticalTabPanel.superclass.getFrameHeight.call(this)-(this.verticalTabs?this.header.getHeight():0)}});Ext.reg("verticaltabpanel",Ext.ux.VerticalTabPanel);
/*(c) Copyright 2008 Licensed under LGPL3. See details below*/
Ext.namespace("Ext.ux.layout");
/*
 * Carousel Layout.
 * <br>
 * <br>See the following for a <a href="http://extjs-ux.org/repo/authors/jerrybrown5/trunk/Ext/ux/layout/Carousel/Demo.html">demo</a>
 * <br>
 * <br> Example Usage
 * <pre>
 *     margins: '5 5 5 0',
 *     title: 'Photos',
 *     layoutConfig: {
 *         pagedScroll: true
 *     },
 *     layout: '<b>carousel</b>',
 *     items: [{
 *         title: "First",
 *         style: {
 *             margin: '5px 5px 5px 5px'
 *         },
 *         width: 120,
 *         html: "&lt;img src='../view/images/thumbs/dance_fever.jpg'>"
 *     }]
 * </pre>
 * <br>Forum thread: <a href="http://extjs.com/forum/showthread.php?t=47672">http://extjs.com/forum/showthread.php?t=47672</a>
 * @class Ext.ux.layout.Carousel
 * @author Nigel White aka Animal; updated by Jerry Brown, published by SamuraiJack
 * @license Ext.ux.layout.Carousel is licensed under the terms of
 * the Open Source <a href="http://www.gnu.org/licenses/lgpl.html">LGPL 3.0 license</a>.  Commercial use is permitted to the extent
 * that the code/component(s) do NOT become part of another Open Source or Commercially
 * licensed development library or toolkit without explicit permission.
 * @version 0.2
 */
Ext.ux.layout.Carousel=Ext.extend(Ext.layout.ContainerLayout,{constructor:function(a){a=a||{};if(!(a.chunkedScroll||a.pagedScroll)){Ext.applyIf(a,{scrollIncrement:10,scrollRepeatInterval:10,marginScrollButtons:12,animScroll:false})}Ext.ux.layout.Carousel.superclass.constructor.call(this,a);if(this.chunkedScroll||this.pagedScroll){this.scrollRepeatInterval=this.scrollDuration*1000;this.scrollAnimationConfig={duration:this.chunkedScroll?this.scrollDuration:this.scrollDuration*2,callback:this.updateScrollButtons,scope:this}}else{this.scrollAnimationConfig=this.animScroll?{duration:this.scrollDuration,callback:this.updateScrollButtons,scope:this}:false}},marginScrollButtons:10,scrollIncrement:10,scrollRepeatInterval:10,scrollDuration:0.35,animScroll:true,chunkedScroll:false,pagedScroll:false,loopCount:0,loopPictureDelay:5,monitorResize:true,scrollButtonPosition:"right",leftScrollButtonClickCls:"x-carousel-left-scrollbutton-click",rightScrollButtonClickCls:"x-carousel-right-scrollbutton-click",leftScrollButtonOverCls:"x-carousel-left-scrollbutton-over",rightScrollButtonOverCls:"x-carousel-right-scrollbutton-over",loopImages:function(){if(this.loopCount<=0){return}var a=this.getScrollTo(1);if(a){a=Math.min(this.getMaxScrollPos(),a);if(a!=this.getScrollPos()){this.scrollTo(a)}else{return}}else{this.scrollTo(0);this.loopCount--;if(this.loopCount<=0){return}}this.loopImages.defer(this.loopPictureDelay*1000,this)},onLayout:function(d,f){var e=d.items.items,a=e.length,g,b;if(!this.scrollWrap){this.scrollWrap=f.createChild({cls:"x-carousel-layout",cn:[{tag:this.scrollElementTag||"div",cls:"x-carousel-scroller",cn:{cls:"x-carousel-body"}},{cls:"x-carousel-left-scrollbutton",style:{height:"100%"}},{cls:"x-carousel-right-scrollbutton",style:{height:"100%"}}]});this.scrollWrap.addClass("x-scroll-button-position-"+this.scrollButtonPosition);this.scrollLeft=this.scrollWrap.child(".x-carousel-left-scrollbutton");this.scrollRight=this.scrollWrap.child(".x-carousel-right-scrollbutton");this.scroller=this.scrollWrap.child(".x-carousel-scroller");this.strip=this.scroller.child(".x-carousel-body");this.scrollLeft.addClassOnClick(this.leftScrollButtonClickCls);this.scrollRight.addClassOnClick(this.rightScrollButtonClickCls);this.scrollLeft.addClassOnOver(this.leftScrollButtonOverCls);this.scrollRight.addClassOnOver(this.rightScrollButtonOverCls);if(this.pagedScroll){this.scrollLeft.on("click",this.onScrollLeftClick,this);this.scrollRight.on("click",this.onScrollRightClick,this)}else{this.leftRepeater=new Ext.util.ClickRepeater(this.scrollLeft,{interval:this.pagedScroll?10000:this.scrollRepeatInterval,delay:0,handler:this.onScrollLeftClick,scope:this});this.rightRepeater=new Ext.util.ClickRepeater(this.scrollRight,{interval:this.pagedScroll?10000:this.scrollRepeatInterval,delay:0,handler:this.onScrollRightClick,scope:this})}this.renderAll(d,this.strip)}this.scroller.setWidth(this.container.getLayoutTarget().getWidth()-(this.scrollLeft.getWidth()+this.scrollRight.getWidth()+this.marginScrollButtons));this.updateScrollButtons.defer(10,this);if(this.loopCount>0&&(this.chunkedScroll||this.pagedScroll)&&!this.startedLoop){this.startedLoop=true;this.loopImages.defer(this.loopPictureDelay*1000,this)}},renderItem:function(d,a,b){if(d){if(d.initialConfig){if(d.rendered){if(typeof a=="number"){a=b.dom.childNodes[a]}b.dom.insertBefore(d.getEl().dom,a||null)}else{d.render(b,a)}}else{if(d instanceof Ext.Element){d.el=d;if(typeof a=="number"){a=b.dom.childNodes[a]}b.dom.insertBefore(d.dom,a||null)}}}d.el.addClass("x-carousel-item")},onResize:function(e,a,d){Ext.ux.layout.Carousel.superclass.onResize.apply(this,arguments);if(Ext.isIE){this.scrollLeft.setHeight(this.scroller.getHeight());this.scrollRight.setHeight(this.scroller.getHeight())}this.setItemsEdges();var b=this.getMaxScrollPos();if(this.getScrollPos()>b){this.scrollTo(b)}},setItemsEdges:function(){var n=this.strip.getLeft();var p=this.container.items.items;var h=p.length;for(var j=0;j<h;j++){var m=p[j];var k=m.el;var o=k.getBox();var g=o.x-n;var d=o.right-n;m.edges={left:g,leftAnchor:g,right:d,rightAnchor:d};if(j==0){k.setStyle({"margin-left":"0px"})}else{if(j==p.length-1){k.setStyle({"margin-right":"0px"})}var f=p[j-1];var a=((g-f.edges.right)/2);f.edges.rightAnchor+=a;m.edges.leftAnchor-=a}}this.itemWidth=p[h-1].edges.rightAnchor/h},getNextOnLeft:function(){var b=this.container.items.items;if(b.length){for(var a=b.length-1;a>-1;a--){if(b[a].edges.left<this.getScrollPos()){return b[a]}}}},getNextOnRight:function(){var d=this.container.items.items;if(d.length){var b=this.scroller.dom.scrollLeft+this.getClientWidth();for(var c=0,a=d.length;c<a;c++){if(d[c].edges.right>b){return d[c]}}}},onScrollRightClick:function(){this.loopCount=0;var a=this.getScrollTo(1);if(a){a=Math.min(this.getMaxScrollPos(),a);if(a!=this.getScrollPos()){this.scrollTo(a)}}},onScrollLeftClick:function(){this.loopCount=0;var a=Math.max(0,this.getScrollTo(-1));if(a!=this.getScrollPos()){this.scrollTo(a)}},scrollTo:function(b){if(this.scrollAnimationConfig){var a=Math.abs(this.getScrollPos()-b);this.scrollAnimationConfig.duration=this.scrollDuration*(a/this.itemWidth)}this.scroller.scrollTo("left",b,this.scrollAnimationConfig);if(!this.scrollAnimationConfig){this.updateScrollButtons()}},updateScrollButtons:function(){var a=this.getScrollPos();this.scrollLeft[(a==0)?"addClass":"removeClass"]("x-tab-scroller-left-disabled");this.scrollRight[(a>=this.getMaxScrollPos())?"addClass":"removeClass"]("x-tab-scroller-right-disabled")},getScrollWidth:function(){var a=this.container.items.items;if(a.length&&!a[0].edges){this.setItemsEdges()}return a.length?a[a.length-1].edges.rightAnchor:0},getScrollPos:function(){return this.scroller.dom.scrollLeft||0},getMaxScrollPos:function(){return this.getScrollWidth()-this.getClientWidth()},getClientWidth:function(){return this.scroller.dom.clientWidth||0},getScrollTo:function(c){var d=this.getScrollPos();if(this.chunkedScroll||this.pagedScroll){if(c==-1){var b=this.getNextOnLeft();if(b){if(this.pagedScroll){return b.edges.rightAnchor-this.getClientWidth()}else{return b.edges.leftAnchor}}}else{var a=this.getNextOnRight();if(a){if(this.pagedScroll){return a.edges.leftAnchor}else{return(a.edges.rightAnchor-this.getClientWidth())}}}}else{return(c==-1)?d-this.scrollIncrement:d+this.scrollIncrement}},isValidParent:function(b,a){return true}});Ext.Container.LAYOUTS.carousel=Ext.ux.layout.Carousel;
/*
 * Ext JS Library 3.2.1
 * Copyright(c) 2006-2010 Ext JS, Inc.
 * licensing@extjs.com
 * http://www.extjs.com/license
 */
if(!Array.prototype.map){Array.prototype.map=function(b){var a=this.length;if(typeof b!="function"){throw new TypeError()}var e=new Array(a);var d=arguments[1];for(var c=0;c<a;c++){if(c in this){e[c]=b.call(d,this[c],c,this)}}return e}}if(!Array.prototype.filter){Array.prototype.filter=function(b){var a=this.length;if(typeof b!="function"){throw new TypeError()}var e=new Array();var d=arguments[1];for(var c=0;c<a;c++){if(c in this){var f=this[c];if(b.call(d,f,c,this)){e.push(f)}}}return e}}Ext.ns("Ext.ux.data");Ext.ux.data.PagingMemoryProxy=Ext.extend(Ext.data.MemoryProxy,{constructor:function(a){Ext.ux.data.PagingMemoryProxy.superclass.constructor.call(this);this.data=a},doRequest:function(d,f,c,g,j,k,l){c=c||{};var m;try{m=g.readRecords(this.data)}catch(h){this.fireEvent("loadexception",this,l,null,h);j.call(k,null,l,false);return}if(c.filter!==undefined){var a={};if(typeof(c.filter)=="object"){a=c.filter}else{a[c.filterCol||0]=c.filter}Ext.iterate(a,function(e,n){m.records=m.records.filter(function(o){if(typeof(o)=="object"){return String(o.data[e]).match(n)?true:false}else{return String(o).match(c.filter)?true:false}})});m.totalRecords=m.records.length}if(c.sort!==undefined){var b=String(c.dir).toUpperCase()=="DESC"?-1:1;var i=function(n,e){return n>e?1:(n<e?-1:0)};m.records.sort(function(n,e){var o=0;if(typeof(n)=="object"){o=i(n.data[c.sort],e.data[c.sort])*b}else{o=i(n,e)*b}if(o==0){o=(n.index<e.index?-1:1)}return o})}if(c.start!==undefined&&c.limit!==undefined){m.records=m.records.slice(c.start,c.start+c.limit)}j.call(k,m,l,true)}});Ext.data.PagingMemoryProxy=Ext.ux.data.PagingMemoryProxy;
/*
 * Ext JS Library 3.2.1
 * Copyright(c) 2006-2010 Ext JS, Inc.
 * licensing@extjs.com
 * http://www.extjs.com/license
 */
Ext.ns("Ext.ux.form");Ext.ux.form.FileUploadField=Ext.extend(Ext.form.TextField,{buttonText:"Browse...",buttonOnly:false,buttonOffset:3,readOnly:true,autoSize:Ext.emptyFn,initComponent:function(){Ext.ux.form.FileUploadField.superclass.initComponent.call(this);this.addEvents("fileselected")},onRender:function(c,a){Ext.ux.form.FileUploadField.superclass.onRender.call(this,c,a);this.wrap=this.el.wrap({cls:"x-form-field-wrap x-form-file-wrap"});this.el.addClass("x-form-file-text");this.el.dom.removeAttribute("name");this.createFileInput();var b=Ext.applyIf(this.buttonCfg||{},{text:this.buttonText});this.button=new Ext.Button(Ext.apply(b,{renderTo:this.wrap,cls:"x-form-file-btn"+(b.iconCls?" x-btn-icon":"")}));if(this.buttonOnly){this.el.hide();this.wrap.setWidth(this.button.getEl().getWidth())}this.bindListeners();this.resizeEl=this.positionEl=this.wrap},bindListeners:function(){this.fileInput.on({scope:this,mouseenter:function(){this.button.addClass(["x-btn-over","x-btn-focus"])},mouseleave:function(){this.button.removeClass(["x-btn-over","x-btn-focus","x-btn-click"])},mousedown:function(){this.button.addClass("x-btn-click")},mouseup:function(){this.button.removeClass(["x-btn-over","x-btn-focus","x-btn-click"]);if(Ext.isSafari){var a=Ext.getBody().mask();a.setStyle({zIndex:40000,opacity:0});a.on("click",function(){Ext.getBody().unmask()})}},change:function(){if(Ext.isSafari){Ext.getBody().unmask()}var a=this.fileInput.dom.value;this.setValue(a);this.fireEvent("fileselected",this,a)}})},createFileInput:function(){this.fileInput=this.wrap.createChild({id:this.getFileInputId(),name:this.name||this.getId(),cls:"x-form-file",tag:"input",type:"file",size:1,tabindex:-1})},reset:function(){this.fileInput.remove();this.createFileInput();this.bindListeners();Ext.ux.form.FileUploadField.superclass.reset.call(this)},getFileInputId:function(){return this.id+"-file"},onResize:function(a,b){Ext.ux.form.FileUploadField.superclass.onResize.call(this,a,b);this.wrap.setWidth(a);if(!this.buttonOnly){var a=this.wrap.getWidth()-this.button.getEl().getWidth()-this.buttonOffset;this.el.setWidth(a)}},onDestroy:function(){Ext.ux.form.FileUploadField.superclass.onDestroy.call(this);Ext.destroy(this.fileInput,this.button,this.wrap)},onDisable:function(){Ext.ux.form.FileUploadField.superclass.onDisable.call(this);this.doDisable(true)},onEnable:function(){Ext.ux.form.FileUploadField.superclass.onEnable.call(this);this.doDisable(false)},doDisable:function(a){this.fileInput.dom.disabled=a;this.button.setDisabled(a)},preFocus:Ext.emptyFn,alignErrorIcon:function(){this.errorIcon.alignTo(this.wrap,"tl-tr",[2,0])}});Ext.reg("fileuploadfield",Ext.ux.form.FileUploadField);Ext.form.FileUploadField=Ext.ux.form.FileUploadField;